// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: generationmodule/generationmodule.proto

package openfmb.generationmodule;

/**
 * <pre>
 * Generation discrete control
 * </pre>
 *
 * Protobuf type {@code generationmodule.DroopParameter}
 */
public final class DroopParameter extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:generationmodule.DroopParameter)
    DroopParameterOrBuilder {
private static final long serialVersionUID = 0L;
  // Use DroopParameter.newBuilder() to construct.
  private DroopParameter(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private DroopParameter() {
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new DroopParameter();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return openfmb.generationmodule.Generationmodule.internal_static_generationmodule_DroopParameter_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return openfmb.generationmodule.Generationmodule.internal_static_generationmodule_DroopParameter_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            openfmb.generationmodule.DroopParameter.class, openfmb.generationmodule.DroopParameter.Builder.class);
  }

  public static final int SLOPE_FIELD_NUMBER = 1;
  private com.google.protobuf.FloatValue slope_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.google.protobuf.FloatValue slope = 1;</code>
   * @return Whether the slope field is set.
   */
  @java.lang.Override
  public boolean hasSlope() {
    return slope_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.google.protobuf.FloatValue slope = 1;</code>
   * @return The slope.
   */
  @java.lang.Override
  public com.google.protobuf.FloatValue getSlope() {
    return slope_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : slope_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.google.protobuf.FloatValue slope = 1;</code>
   */
  @java.lang.Override
  public com.google.protobuf.FloatValueOrBuilder getSlopeOrBuilder() {
    return slope_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : slope_;
  }

  public static final int UNLOADEDOFFSET_FIELD_NUMBER = 2;
  private com.google.protobuf.FloatValue unloadedOffset_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.google.protobuf.FloatValue unloadedOffset = 2;</code>
   * @return Whether the unloadedOffset field is set.
   */
  @java.lang.Override
  public boolean hasUnloadedOffset() {
    return unloadedOffset_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.google.protobuf.FloatValue unloadedOffset = 2;</code>
   * @return The unloadedOffset.
   */
  @java.lang.Override
  public com.google.protobuf.FloatValue getUnloadedOffset() {
    return unloadedOffset_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : unloadedOffset_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.google.protobuf.FloatValue unloadedOffset = 2;</code>
   */
  @java.lang.Override
  public com.google.protobuf.FloatValueOrBuilder getUnloadedOffsetOrBuilder() {
    return unloadedOffset_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : unloadedOffset_;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (slope_ != null) {
      output.writeMessage(1, getSlope());
    }
    if (unloadedOffset_ != null) {
      output.writeMessage(2, getUnloadedOffset());
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (slope_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, getSlope());
    }
    if (unloadedOffset_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(2, getUnloadedOffset());
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof openfmb.generationmodule.DroopParameter)) {
      return super.equals(obj);
    }
    openfmb.generationmodule.DroopParameter other = (openfmb.generationmodule.DroopParameter) obj;

    if (hasSlope() != other.hasSlope()) return false;
    if (hasSlope()) {
      if (!getSlope()
          .equals(other.getSlope())) return false;
    }
    if (hasUnloadedOffset() != other.hasUnloadedOffset()) return false;
    if (hasUnloadedOffset()) {
      if (!getUnloadedOffset()
          .equals(other.getUnloadedOffset())) return false;
    }
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (hasSlope()) {
      hash = (37 * hash) + SLOPE_FIELD_NUMBER;
      hash = (53 * hash) + getSlope().hashCode();
    }
    if (hasUnloadedOffset()) {
      hash = (37 * hash) + UNLOADEDOFFSET_FIELD_NUMBER;
      hash = (53 * hash) + getUnloadedOffset().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static openfmb.generationmodule.DroopParameter parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.generationmodule.DroopParameter parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.generationmodule.DroopParameter parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.generationmodule.DroopParameter parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.generationmodule.DroopParameter parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.generationmodule.DroopParameter parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.generationmodule.DroopParameter parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.generationmodule.DroopParameter parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.generationmodule.DroopParameter parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static openfmb.generationmodule.DroopParameter parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.generationmodule.DroopParameter parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.generationmodule.DroopParameter parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(openfmb.generationmodule.DroopParameter prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * Generation discrete control
   * </pre>
   *
   * Protobuf type {@code generationmodule.DroopParameter}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:generationmodule.DroopParameter)
      openfmb.generationmodule.DroopParameterOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return openfmb.generationmodule.Generationmodule.internal_static_generationmodule_DroopParameter_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return openfmb.generationmodule.Generationmodule.internal_static_generationmodule_DroopParameter_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              openfmb.generationmodule.DroopParameter.class, openfmb.generationmodule.DroopParameter.Builder.class);
    }

    // Construct using openfmb.generationmodule.DroopParameter.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      slope_ = null;
      if (slopeBuilder_ != null) {
        slopeBuilder_.dispose();
        slopeBuilder_ = null;
      }
      unloadedOffset_ = null;
      if (unloadedOffsetBuilder_ != null) {
        unloadedOffsetBuilder_.dispose();
        unloadedOffsetBuilder_ = null;
      }
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return openfmb.generationmodule.Generationmodule.internal_static_generationmodule_DroopParameter_descriptor;
    }

    @java.lang.Override
    public openfmb.generationmodule.DroopParameter getDefaultInstanceForType() {
      return openfmb.generationmodule.DroopParameter.getDefaultInstance();
    }

    @java.lang.Override
    public openfmb.generationmodule.DroopParameter build() {
      openfmb.generationmodule.DroopParameter result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public openfmb.generationmodule.DroopParameter buildPartial() {
      openfmb.generationmodule.DroopParameter result = new openfmb.generationmodule.DroopParameter(this);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartial0(openfmb.generationmodule.DroopParameter result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        result.slope_ = slopeBuilder_ == null
            ? slope_
            : slopeBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000002) != 0)) {
        result.unloadedOffset_ = unloadedOffsetBuilder_ == null
            ? unloadedOffset_
            : unloadedOffsetBuilder_.build();
      }
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof openfmb.generationmodule.DroopParameter) {
        return mergeFrom((openfmb.generationmodule.DroopParameter)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(openfmb.generationmodule.DroopParameter other) {
      if (other == openfmb.generationmodule.DroopParameter.getDefaultInstance()) return this;
      if (other.hasSlope()) {
        mergeSlope(other.getSlope());
      }
      if (other.hasUnloadedOffset()) {
        mergeUnloadedOffset(other.getUnloadedOffset());
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              input.readMessage(
                  getSlopeFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000001;
              break;
            } // case 10
            case 18: {
              input.readMessage(
                  getUnloadedOffsetFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000002;
              break;
            } // case 18
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private com.google.protobuf.FloatValue slope_;
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> slopeBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue slope = 1;</code>
     * @return Whether the slope field is set.
     */
    public boolean hasSlope() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue slope = 1;</code>
     * @return The slope.
     */
    public com.google.protobuf.FloatValue getSlope() {
      if (slopeBuilder_ == null) {
        return slope_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : slope_;
      } else {
        return slopeBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue slope = 1;</code>
     */
    public Builder setSlope(com.google.protobuf.FloatValue value) {
      if (slopeBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        slope_ = value;
      } else {
        slopeBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue slope = 1;</code>
     */
    public Builder setSlope(
        com.google.protobuf.FloatValue.Builder builderForValue) {
      if (slopeBuilder_ == null) {
        slope_ = builderForValue.build();
      } else {
        slopeBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue slope = 1;</code>
     */
    public Builder mergeSlope(com.google.protobuf.FloatValue value) {
      if (slopeBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0) &&
          slope_ != null &&
          slope_ != com.google.protobuf.FloatValue.getDefaultInstance()) {
          getSlopeBuilder().mergeFrom(value);
        } else {
          slope_ = value;
        }
      } else {
        slopeBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue slope = 1;</code>
     */
    public Builder clearSlope() {
      bitField0_ = (bitField0_ & ~0x00000001);
      slope_ = null;
      if (slopeBuilder_ != null) {
        slopeBuilder_.dispose();
        slopeBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue slope = 1;</code>
     */
    public com.google.protobuf.FloatValue.Builder getSlopeBuilder() {
      bitField0_ |= 0x00000001;
      onChanged();
      return getSlopeFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue slope = 1;</code>
     */
    public com.google.protobuf.FloatValueOrBuilder getSlopeOrBuilder() {
      if (slopeBuilder_ != null) {
        return slopeBuilder_.getMessageOrBuilder();
      } else {
        return slope_ == null ?
            com.google.protobuf.FloatValue.getDefaultInstance() : slope_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue slope = 1;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> 
        getSlopeFieldBuilder() {
      if (slopeBuilder_ == null) {
        slopeBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder>(
                getSlope(),
                getParentForChildren(),
                isClean());
        slope_ = null;
      }
      return slopeBuilder_;
    }

    private com.google.protobuf.FloatValue unloadedOffset_;
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> unloadedOffsetBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue unloadedOffset = 2;</code>
     * @return Whether the unloadedOffset field is set.
     */
    public boolean hasUnloadedOffset() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue unloadedOffset = 2;</code>
     * @return The unloadedOffset.
     */
    public com.google.protobuf.FloatValue getUnloadedOffset() {
      if (unloadedOffsetBuilder_ == null) {
        return unloadedOffset_ == null ? com.google.protobuf.FloatValue.getDefaultInstance() : unloadedOffset_;
      } else {
        return unloadedOffsetBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue unloadedOffset = 2;</code>
     */
    public Builder setUnloadedOffset(com.google.protobuf.FloatValue value) {
      if (unloadedOffsetBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        unloadedOffset_ = value;
      } else {
        unloadedOffsetBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue unloadedOffset = 2;</code>
     */
    public Builder setUnloadedOffset(
        com.google.protobuf.FloatValue.Builder builderForValue) {
      if (unloadedOffsetBuilder_ == null) {
        unloadedOffset_ = builderForValue.build();
      } else {
        unloadedOffsetBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue unloadedOffset = 2;</code>
     */
    public Builder mergeUnloadedOffset(com.google.protobuf.FloatValue value) {
      if (unloadedOffsetBuilder_ == null) {
        if (((bitField0_ & 0x00000002) != 0) &&
          unloadedOffset_ != null &&
          unloadedOffset_ != com.google.protobuf.FloatValue.getDefaultInstance()) {
          getUnloadedOffsetBuilder().mergeFrom(value);
        } else {
          unloadedOffset_ = value;
        }
      } else {
        unloadedOffsetBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue unloadedOffset = 2;</code>
     */
    public Builder clearUnloadedOffset() {
      bitField0_ = (bitField0_ & ~0x00000002);
      unloadedOffset_ = null;
      if (unloadedOffsetBuilder_ != null) {
        unloadedOffsetBuilder_.dispose();
        unloadedOffsetBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue unloadedOffset = 2;</code>
     */
    public com.google.protobuf.FloatValue.Builder getUnloadedOffsetBuilder() {
      bitField0_ |= 0x00000002;
      onChanged();
      return getUnloadedOffsetFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue unloadedOffset = 2;</code>
     */
    public com.google.protobuf.FloatValueOrBuilder getUnloadedOffsetOrBuilder() {
      if (unloadedOffsetBuilder_ != null) {
        return unloadedOffsetBuilder_.getMessageOrBuilder();
      } else {
        return unloadedOffset_ == null ?
            com.google.protobuf.FloatValue.getDefaultInstance() : unloadedOffset_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.google.protobuf.FloatValue unloadedOffset = 2;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder> 
        getUnloadedOffsetFieldBuilder() {
      if (unloadedOffsetBuilder_ == null) {
        unloadedOffsetBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            com.google.protobuf.FloatValue, com.google.protobuf.FloatValue.Builder, com.google.protobuf.FloatValueOrBuilder>(
                getUnloadedOffset(),
                getParentForChildren(),
                isClean());
        unloadedOffset_ = null;
      }
      return unloadedOffsetBuilder_;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:generationmodule.DroopParameter)
  }

  // @@protoc_insertion_point(class_scope:generationmodule.DroopParameter)
  private static final openfmb.generationmodule.DroopParameter DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new openfmb.generationmodule.DroopParameter();
  }

  public static openfmb.generationmodule.DroopParameter getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<DroopParameter>
      PARSER = new com.google.protobuf.AbstractParser<DroopParameter>() {
    @java.lang.Override
    public DroopParameter parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<DroopParameter> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<DroopParameter> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public openfmb.generationmodule.DroopParameter getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

